﻿'Copyright (C) 2009 Christiaan Cable
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 3
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details (LICENCE.TXT).

Imports System.Net
Imports System.Windows.Forms

Public Class Cirrus
    Public ISPReturnData As New ISPReturnData
    Private CookieContainer As New System.Net.CookieContainer

    Public Sub New(ByVal ConfigurationData As ConfigurationData)

        Try
            'set rollover date
            SetRolloverDate(ConfigurationData, ISPReturnData)

            Dim strHTMLData As String

            'create credentials
            Dim cCache As New CredentialCache
            cCache.Add(New Uri("https://cms.cirruscomms.com.au/custdata/login.php3"), "Basic", New NetworkCredential(ConfigurationData.Username, ConfigurationData.Password))

            'login
            strHTMLData = ISPGet("https://cms.cirruscomms.com.au/custdata/login.php3", CookieContainer, cCache)

            'process response
            If strHTMLData = "" Then
                ISPReturnData.ErrorMessage = "Login Failed"
                Exit Sub
            End If

            'get login id
            Dim LoginID As String = ExtractText(strHTMLData, "login_id", 0, "=", """")

            'process response
            If LoginID = "" Then
                ISPReturnData.ErrorMessage = "Could not determine Login ID"
                Exit Sub
            End If

            'usage
            strHTMLData = ISPGet("https://cms.cirruscomms.com.au/custdata/time-block-list.php3?login_id=" & LoginID, CookieContainer, cCache)

            If UA.DebugISP = True Then My.Computer.FileSystem.WriteAllText(GetAppDataPath() & "debug.htm", strHTMLData, False, System.Text.Encoding.ASCII)

            'usage
            Dim strData As String = ExtractText(strHTMLData, "B<BR>", 0, "", "<")
            strData = Replace(strData, "&nbsp;", " ")
            Dim strDown As String = ExtractText(strData, "(", 0, "", " down")
            Dim strUp As String = ExtractText(strData, "/", 0, "", " up")

            ISPReturnData.PeakDownload = CSng(Val(strDown))
            If strDown.EndsWith("GB") Then ISPReturnData.PeakDownload *= 1000

            ISPReturnData.PeakUpload = CSng(Val(strUp))
            If strUp.EndsWith("GB") Then ISPReturnData.PeakUpload *= 1000

            If ConfigurationData.UploadCounted = True Then
                ISPReturnData.PeakDownload += ISPReturnData.PeakUpload
            End If

            ISPReturnData.LastUpdated = Now

            '##########################################################

            ProcessISPData(ConfigurationData, ISPReturnData)

            'check for error
            If ISPReturnData.ErrorMessage <> "" Then Exit Sub

            '##########################################################

            'create graph data

            'usage
            ISPReturnData.GraphItemList.Add(New GraphItem("Usage " & Format(System.Math.Floor((ISPReturnData.PeakDownload / Val(ConfigurationData.PeakUsageLimit)) * 1000) / 10, "#0.0") & "% (" & ISPReturnData.PeakDownload & " MB)", ISPReturnData.PeakDownload, CSng(Val(ConfigurationData.PeakUsageLimit)), False))

            'days elapsed
            ISPReturnData.GraphItemList.Add(New GraphItem("Days Elapsed " & Format((ISPReturnData.DaysUsed / (ISPReturnData.DaysUsed + ISPReturnData.DaysLeft)) * 100, "#0") & "% (" & ISPReturnData.DaysUsed & " Days)", ISPReturnData.DaysUsed, ISPReturnData.DaysUsed + ISPReturnData.DaysLeft, False))

            '##########################################################

            'create stats data
            ISPReturnData.TextItemList.Add(New TextItem("Usage Left :", ISPReturnData.PeakUsageRemainingDescription))
            ISPReturnData.TextItemList.Add(New TextItem("Usage Avg. Left :", ISPReturnData.PeakUsageRemainingPerDayDescription))

            If ConfigurationData.UploadCounted = True Then
                ISPReturnData.TextItemList.Add(New TextItem("Downloads :", ISPReturnData.PeakDownload - ISPReturnData.PeakUpload & " MB"))
            Else
                ISPReturnData.TextItemList.Add(New TextItem("Downloads :", ISPReturnData.PeakDownload & " MB"))
            End If

            ISPReturnData.TextItemList.Add(New TextItem("Uploads :", ISPReturnData.PeakUpload & " MB"))

            If ISPReturnData.ShapedNow = False Then
                ISPReturnData.TextItemList.Add(New TextItem("Shaped :", "NO"))
            Else
                ISPReturnData.TextItemList.Add(New TextItem("Shaped :", "YES"))
            End If

            '##########################################################

            'process alerts
            ProcessAlerts(ConfigurationData, ISPReturnData)

        Catch ex As Exception
            ISPReturnData.ErrorMessage = ex.Message
        End Try
    End Sub

End Class
